const Input = ({ htl, value = "" } = {}) => {
  function set(input, value) {
    input.value = value;
    input.dispatchEvent(new Event("input", { bubbles: true })); // Native events bubble, so we should too
  }

  let node = null;
  const input = () => htl.html.fragment`<input oninput=${(ev) => set(node, ev.target.value)} value="${value}"></input>`;

  node = htl.html`<div class="zhstat-input">${input()}</div>`;

  // Update the display whenever the value changes
  Object.defineProperty(node, "value", {
    get() {
      return value;
    },
    set(v) {
      value = v;
    }
  });

  // Set the initial value
  node.value = value;

  return node;
}

export {
  Input
}